#!/usr/local/bin/perl
#===============================================================================
# xls2cfg-GUI.pl
#   Usage: xls2cfg.pl
#   2004/09/01 Version 1.0 Release
# created by Takashi-Ohmoto
#===============================================================================

use Win32::GUI::TabFrame;
use Win32::GUI;
use Date::Calc qw(:all);
use Win32::OLE qw(in with);
use Win32::OLE::Const 'Microsoft Excel';
$Win32::OLE::Warn = 0;                                # die on errors...


#Initial Global
$my_version = "1.00";
$my_name    = "xls2cfg-GUI";
$verbose    = 0;
$debug1     = 0;
$debug2     = 0;
$Font1      = new Win32::GUI::Font(
	            -name => "lr SVbN",
	            -size => 9,
              );

#Initial Application
$Excel      = ""; #Excel Objectwp
$Book       = ""; #WorkBookwp
$Sheet      = ""; #WorkSheetwp
$ws_count   = ""; #Work_Sheet̐i[
$max_rows   = ""; #Work_Sheet̍Ō̍sԍi[
$max_cols   = ""; #Work_Sheet̍Ō̗ԍi[
@par_lst    = (); #

@Type1_Fields = (
  "Banner exec Parameter",
  "Banner login Parameter",
  "General Service configration Parameter",
  "Static Arp Parameter",
  "MAC Address Aging Parameter",
  "Static Route Parameter",
  "Route MAP Parameter",
  "ACL Parameter",
  "OSPF Advertise Network Parameter",
  "OSPF Passive Interface Parameter",
  "OSPF Redistribute Parameter",
  "BGP Neighbor Parameter",
  "BGP Aggregate-address Parameter",
  "BGP Advertise Network Parameter",
  "BGP Passive Interface Parameter",
  "BGP Redistribute Parameter",
  "Other Configration Parameter",
  );

@Type2_Fields = (
  "Global Parameter",
  "NTP Parameter",
  "Syslog Parameter",
  "SNMP Parameter",
  "OSPF Process Parameter",
  "BGP Process Parameter",
  "VLAN Protocol Parameter",
  );

@Type2_regexp = (
  #"ϐ(tB[h,K\,u"
  "hostname,hostname ,replace",
  "boot system,boot system ,replace",
  "boot system2,boot system ,replace",
  "logging buffered,logging buffered ,replace",
  "default gateway,ip default-gateway ,replace",
  "diagnostic level,diagnostic level ,replace",
  "fabric lcd banner,fabric lcd banner ^,append_^",
  "Clock Timezone,clock timezone ,replace",
  "NTP Master,ntp master ,replace",
  "NTP Server IP1,ntp server ,replace",
  "NTP Server IP2,ntp server ,replace",
  "Update Calender,ntp update-calendar,drop",
  "Syslog Server IP1,logging ,replace",
  "Logging Level,logging trap ,replace",
  "Logging Facility,logging facility ,replace",
  "Community RO,snmp-server community ,append_ RO",
  "Community RW,snmp-server community ,append_ RW",
  "Trap Host,snmp-server host ,chomp",
  "Trap Community, ,chomp",
  "Use Trap, ,replace",
  #VLAN
  "VTP Mode,vtp mode ,replace",
  "MST Name, name ,replace",
  "MST Instance 0 vlan, instance 0 vlan ,replace",
  "MST Instance 1 vlan, instance 1 vlan ,replace",
  #OSPF
  "OSPF Process ID,router ospf ,replace",
  "OSPF Router ID, router-id ,replace",
  "OSPF Logging, log-adjacency-changes ,replace",
  #BGP
  "BGP Process ID,router bgp ,replace",
  "BGP Router ID, bgp router-id ,replace",
  "BGP Logging, bgp log-neighbor-changes ,drop",
  "BGP synchronization, synchronization ,choice",
  "BGP auto-summary, auto-summary ,choice",
  );

@Type3_Fields = (
 "Basic Network Parameter",
 );

@Type4_Fields = (
  "VLAN Parameter",
  "HSRP Parameter",
  );







#===============================================================================
# MainWin Create
#===============================================================================

#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#Menu_Bar̒`
#$menu1ƂĒ`
#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$Menu1 = Win32::GUI::MakeMenu(
    "&Options"              => "Options",
    " > &Verbose Mode"      => { -name => "Verbose", -checked => 0 },
    " > -"                  => 0,
    " > Debug Lv&1"         => { -name => "DebugLv1", -checked => 0 },
    " > Debug Lv&2"         => { -name => "DebugLv2", -checked => 0 },
    " > -"                  => 0,
    " > &About..."          => "About",
    " > E&xit"              => "Exit",
);



#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
# MainWin
#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$MainWin = new GUI::Window(
    -name   => "MainWin",
    -text   => "$my_name Version $my_version",
    -height => 540,
    -width  => 690,
    -left   => 100,
    -top    => 100,
    -menu   => $Menu1,
    -font   => $Font1,

);

$MainWin->{-dialogui} = 1;

#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
# SubWin
#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$SubWin = new GUI::Window(
    -name   => "SubWin",
    -text   => "$new",
    -width  => 500,
    -height => 600,
    -font   => $Font1,
);

$TextBox01 = $SubWin->AddRichEdit(
    -name    => "TextBox01",
    -text    => "",
    -top     => 1,
    -left    => 1,
    -width   => 488,
    -height  => 560,
    -style   => WS_CHILD | WS_VISIBLE | WS_VSCROLL
              | ES_LEFT | ES_MULTILINE | ES_AUTOVSCROLL,
    -exstyle => WS_EX_CLIENTEDGE,
    -readonly => 1,
);

#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
# TabPanel
#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$MainWin->AddTabFrame (
    -name   => "Tab",
    -panel  => "Page",
);

$MainWin->Tab->InsertItem(
    -text   => "IOS",
    -border => 0,
);





#===============================================================================
# Tab->Page0 IOS GUI Detail
#===============================================================================

#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#Browse Button & Marge Button̍쐬
#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$MainWin->Tab->Page0->AddButton(
    -name    => "Browse01Button",
  	-top    => 4,
	  -left   => 580,
	  -width  => 60,
	  -height => 20,
	  -text    => "Browse",
	  -tabstop => 1,
);

$Browse01Field = $MainWin->Tab->Page0->AddTextfield(
    -name => "Browse01Field",
    -text   => "",
    -top    => 4,
    -left   => 107,
    -width  => 470,
    -height => 20,
);

$Browse01Label = $MainWin->Tab->Page0->AddLabel(
    -top => 9,
    -left => 8,
    -width => 100,
    -height => 20,
    -style => 2,
    -name => "Browse01Label",
    -visible => 10,
    -text => "Config-Sheet:",
);


$MainWin->Tab->Page0->AddButton(
    -name    => "Run01Button",
  	-top    => 34,
	  -left   => 580,
	  -width  => 60,
	  -height => 20,
	  -text    => "RUN",
	  -tabstop => 1,
);

#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#List Box̍쐬
#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

$List01Label = $MainWin->Tab->Page0->AddLabel(
    -top => 70,
    -left => 5,
    -width => 125,
    -height => 20,
    -style => 1,
    -name => "List01Label",
    -visible => 10,
    -text => "Include WorkSheet",
);


$List01 = $MainWin->Tab->Page0->AddListbox(
    -name => "List01",
    -addstyle => WS_VSCROLL | WS_CHILD | WS_VISIBLE | 1,
    -top  => 83,
    -left => 5,
    -width => 125,
    -height => 340,
    -menu => 1,
    -tabstop => 1,
    -group => 1,
    -foreground => [1, 1, 1],
    -background => [194, 194, 194],
    -vscroll => 1,
);

$List02Label = $MainWin->Tab->Page0->AddLabel(
    -top => 70,
    -left => 200,
    -width => 125,
    -height => 20,
    -style => 1,
    -name => "List02Label",
    -visible => 10,
    -text => "Selected WorkSheet",
);

$List02 = $MainWin->Tab->Page0->AddListbox(
    -name => "List02",
    -addstyle => WS_VSCROLL | WS_CHILD | WS_VISIBLE | 1,
    -top  => 83,
    -left => 200,
    -width => 125,
    -height => 340,
    -menu => 1,
    -tabstop => 1,
    -group => 1,
    -foreground => [1, 1, 1],
    -background => [194, 194, 194],
    -vscroll => 1,
);

$List03Label = $MainWin->Tab->Page0->AddLabel(
    -top => 70,
    -left => 335,
    -width => 313,
    -height => 20,
    -style => 1,
    -name => "List03Label",
    -visible => 10,
    -text => "Created Config",
);

$List03 = $MainWin->Tab->Page0->AddListbox(
    -name => "List03",
    -addstyle => WS_VSCROLL | WS_CHILD | WS_VISIBLE | 1,
    -top     => 83,
    -left    => 335,
    -width   => 313,
    -height  => 328,
    -menu => 1,
    -tabstop => 1,
    -group => 1,
    -foreground => [1, 1, 1],
    -background => [194, 194, 194],
    -vscroll => 1,
);


=pod
$TextBox01Label = $MainWin->Tab->Page0->AddLabel(
    -top => 70,
    -left => 450,
    -width => 200,
    -height => 20,
    -style => 1,
    -name => "TextBox01Label",
    -visible => 10,
    -text => "Result",
);

$TextBox01 = $MainWin->Tab->Page0->AddTextfield(
    -name    => "TextBox01",
    -text    => "",
    -top     => 83,
    -left    => 450,
    -width   => 200,
    -height  => 328,
    -style   => WS_CHILD | WS_VISIBLE | WS_VSCROLL
              | ES_LEFT | ES_MULTILINE | ES_AUTOVSCROLL,
    -exstyle => WS_EX_CLIENTEDGE,
    -readonly => 1,
);
=cut


$MainWin->Tab->Page0->AddGroupbox(
	-name   => "StatusGroup01",
	-top    => 420,
	-left   => 1,
	-width  => 651,
	-height => 28,
);

$Status01 = $MainWin->Tab->Page0->AddLabel(
    -top => 431,
    -left => 5,
    -width => 645,
    -height => 15,
    -style => 1,
    -visible => 10,
    -text => "",
);

$Add = $MainWin->Tab->Page0->AddButton(
                          -text  => "Add >",
                          -top   => 165,
                          -left  => 140,
                          -width => 50,
                          -menu  => 3,
                          -tabstop => 1,
                          -group => 1,
                          -name  => "Add",
                          -foreground => [255, 255, 255],
);

$AddAll = $MainWin->Tab->Page0->AddButton(-text  => "All >>",
                         -top   => 185,
                         -left  => 140,
                         -width => 50,
                         -menu => 4,
                         -tabstop => 1,
                         -name  => "AddAll") or print_and_die("new Button");

$Remove = $MainWin->Tab->Page0->AddButton(-text  => "< Del",
                         -top   => 205,
                         -left  => 140,
                         -width => 50,
                         -menu  => 5,
                         -name  => "Remove") or print_and_die("new Button");

$RemoveAll = $MainWin->Tab->Page0->AddButton(-text  => "<< All",
                         -top   => 225,
                         -left  => 140,
                         -width => 50,
                         -menu  => 6,
                         -name  => "RemoveAll") or print_and_die("new Button");





#===============================================================================
# Window loop (Don't modified)
#===============================================================================

&Window_Resize ();
$MainWin->Show();
Win32::GUI::Dialog();

sub MainWin_Terminate {
    $MainWin->Disable();
    $MainWin->PostQuitMessage(0);
    exit;
}

sub SubWin_Terminate {
    $SubWin->Hide();
    $MainWin->Enable();
    $MainWin->SetForegroundWindow();
    return 0;
}

sub SubWin_Deactivate {
    $SubWin->Hide();
    $MainWin->Enable();
    $MainWin->SetForegroundWindow();
    return 0;
}


sub Window_Resize {

  $MainWin->Tab->Move (10, 10);
  $MainWin->Tab->Resize($MainWin->ScaleWidth - 20, $MainWin->ScaleHeight - 20);
}


sub About_Click {
    $MainWin->Disable();
    $AboutWin->Show();
    $AboutWin->Enable();
    $AboutWin->Text("About");
    $AboutWin->AddLabel(-text => "ExAn-GUI.Version $version" , -name => 'label');
    $AboutWin->SetFocus();
    return 1;
}

sub AboutWin_Terminate {
    $AboutWin->Disable();
    $MainWin->Enable();
    $MainWin->SetForegroundWindow();
}


#===============================================================================
# MainWin->MenuBar Function
#===============================================================================

sub Verbose_Click {
    $verbose = !$Menu1->{Verbose}->Checked;
    $Menu1->{Verbose}->Checked($verbose);
}

sub DebugLv1_Click {
    $debug1 = !$Menu1->{DebugLv1}->Checked;
    $Menu1->{DebugLv1}->Checked($debug1);
}

sub DebugLv2_Click {
    $debug2 = !$Menu1->{DebugLv2}->Checked;
    $Menu1->{DebugLv2}->Checked($debug2);
}

sub Exit_Click {
    $MainWin->PostQuitMessage(0);
}



#===============================================================================
# Tab->Page0 IOS GUI Function
#===============================================================================
sub Browse01Button_Click {
    $List01->Clear;
    $file_name01 = "";
    $file_name01 = "\0" . " " x 260;
    $file_name01 = GUI::GetOpenFileName(
    -title => "Select EXCEL Config Sheet(IOS) File.",
    -file => $file_name01,
    -filter => [
        "EXCEL Config Sheet (*.xls)" => "*.xls",
        "All files", "*.*",
    ],
    );
    $MainWin->Tab->Page0->Browse01Field->Text("$file_name01");

    $Excel = Win32::OLE->GetActiveObject('Excel.Application')
                || Win32::OLE->new('Excel.Application', 'Quit');
    $Book = $Excel->Workbooks->Open($file_name01);

    $debug1 && print "sub-workbook_perse:WorkBook_perser Exec\n";

    $ws_count = $Excel->ActiveWorkbook->Worksheets->Count;
    $debug1 && print "sub-main:WorkSheet Count = $ws_count\n";            #݂WorkSheet̐擾


    for ($i = 1;$i <= $ws_count;$i++) {
      $max_row;
      $max_col;
      $Sheet = $Book->Worksheets($i);                    # [NV[gPI

      $List01->InsertItem($Sheet->Name);
    }

    $Book->Close;
}

sub Add_Click {
    my $sel = $List01->SelectedItem();
    if($sel != -1) {
        my $new = $List02->InsertItem($List01->GetString($sel));
        $List02->Select($new);
    }
    return 1;
}

sub Remove_Click {
    my $sel = $List02->SelectedItem();
    if($sel != -1) {
        $List02->RemoveItem($sel);
        if($List02->Count > 0) {
            if($sel >= $List02->Count) {
                $List02->Select($List02->Count-1);
            } else {
                $List02->Select($sel);
            }
        }
    }
    return 1;
}

sub AddAll_Click {
    my $temp = $List02->GetString(0);
    if ($temp) {
      $List02->RemoveItem(0);
    }
    for $i (0..$List01->Count-1) {
        $List02->InsertItem($List01->GetString($i));
    }
    $List02->Select($List02->Count-1);
    return 1;
}

sub RemoveAll_Click {
    if($List02->Count > 0) {
        $List02->Clear;
    }
    return 1;
}

sub SrcField11_Change {
    $src = $SrcField11->Text;
}

sub DstField11_Change {
    $dst = $DstField11->Text;
}

sub List01_Click {
    my $sel = $List01->SelectedItem();
    if($sel != -1) {
    }
    return 1;
}

sub List01_DblClick {
    Add_Click();
    $Status01->Text("Add Item");
}

sub List02_Click {
    my $sel = $List02->SelectedItem();
    if($sel != -1) {
    }
    return 1;
}

sub List02_DblClick {
    Remove_Click();
    $Status01->Text("Remove Item");
}

sub List03_Click {
    my $sel = $List03->SelectedItem();
    if($sel != -1) {
    }
    return 1;
}

sub List03_DblClick {
    my $sel = $List03->SelectedItem();
    my $new = $List03->GetString($sel);
    $Status01->Text("Open notepad.exe $new");
    #system("notepad.exe", "$new");
    $MainWin->Disable();
    $SubWin->Show();
    $SubWin->Enable();
    $SubWin->Text("$new");
    $SubWin->SetFocus();
    open(CFG, "$new");
    while ($line=<CFG>) { $TextBox01->ReplaceSel($line); }
    close(CFG);
    return 1;
}

sub Run01Button_Click {
    my $i           = "";
    my $sheet_name  = "";
    my $line        = "";

    $Excel = Win32::OLE->GetActiveObject('Excel.Application')
                || Win32::OLE->new('Excel.Application', 'Quit');
    $Book = $Excel->Workbooks->Open($file_name01);

    @sheet_list = ();
    for $i (0..$List01->Count-1) {
      $sheet_name = $List02->GetString($i);
      unless ($sheet_name eq "") { push (@sheet_list,$sheet_name) };
    }
    #eSheet̏ɂ
    #@sheet_listsheet_nameo
    foreach $sheet_name (@sheet_list) {
      $Status01->Text("Creating $sheet_name config please few minutes.\n");
      $debug1 && print $sheet_name . "\n";
      my $max_row = "";
      my $max_col = "";
      $Sheet = $Book->Worksheets($sheet_name); # [NV[gI
      #ExcelFĂAZ̍ŏIs擾(R1C1)̌v
      $sheet_len = $Sheet->Cells->SpecialCells(xlLastCell)->Address({
                    ReferenceStyle => xlR1C1
                    });
      $debug1 && print "sub-workbook_perse:\$sheet_len = $sheet_len\n";
      $sheet_len =~ /\R(\d+)\C(\d+)/;
      $max_row  = $1;$debug1 && print "sub-workbook_perse:\$max_row = $max_row:\n";
      $max_col  = $2;$debug1 && print "sub-workbook_perse:\$max_col = $max_col\n";
      $debug1 && print "sub-workbook_perse:Sheet = \"" . $Sheet->Name . "\" = rows:$max_row x columns:$max_col\n";            #݂WorkSheet̐擾
      &worksheet_perser($max_row,$max_col);
    }
  $Book->Close;
}
#===============================================================================
# Main Routin
#===============================================================================
#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
sub worksheet_perser {
#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
  $debug1 && print "sub-worksheet_perser:WorkSheet_perser Init\n";
  my $max_row = $_[0];
  my $max_col = $_[1];
  my $line;
  my $a;
  my $row;
  my $nrow;
  my @item_list = ();
  my @item = ();
  @col_lst = ();
  @row_lst = ();
  @collst = ();
  @rowlst = ();
  %parameter_lst  = (); #
  %command        = ();
  $title_num  = 1;

  #Output-Config Init
  @VLAN      =();
  @VLAN_STP  =();
  @INTERFACE =();
  @HSRP      =();
  @OSPF      =();
  @RIP       =();
  @BGP       =();
  @EIGRP     =();

  @Type2_list =();
  @Type3_list =();
  #


  $debug && print "\nsub-worksheet_perser:WorkSheet_perser Exec $max_row\n";

  #Information
  #Information݂@itemɃ^Cg$rowi[
  foreach $row (1..$max_row) {                          #ԍ̎w
     $line = $Sheet->Cells($row,1)->{'Value'};
     $line =~ s/\s/_/g;
     if ($line =~ /(.*)_Information/) { push(@item,"$1,$row") }
    }
    $debug1 && print "sub-worksheet_perser:include \@item --\n @item \n --include \@item end\n";

  #nrow߂
  #InformationrownrowL^@item_listɊi[
  $a = @item;
  $debug1 && print " sub-worksheet_perser:\@item count = $a\n";

  for ($i = 0;$i < $a;$i++) {
   $item[$i+1] =~ /.*,(\d*)/;
   $nrow = $1;
   $debug1 && print " sub-worksheet_perser:" . "\$nrow = " . $nrow . "\n";
   push (@item_list,$item[$i] . "," . $nrow . "\n");
  }
   $debug1 && print " sub-worksheet_perser:include \@item_list\n @item_list";

  #@item_list̒lsoAZ̏ǂݎ
  foreach $line (@item_list) {
    $line =~ /(.*),(.*),(.*)/;
    $row = $2;
    $nrow = $3;
    $debug1 && print " sub-worksheet_perser:\$row = $row:\$nrow = $nrow\n";
    Analyze_Information($row,$nrow,$line,$max_row,$max_col);
    cell_box($max_row,$max_col);

  }
   $debug1 && print " sub-worksheet_perser:Analyze_Information-->Result \n ---Parameter List--- \n" . " @par_lst\n" . "--- End ---\n";

  #foreach my $title (@title_lst) {
  #  $debug && print "sub-worksheet_perser:--- $title include ---\n";
  #  $debug && print @$title;
  #  $debug && print "sub-worksheet_perser:\n--- end ---\n";
  #}

  foreach $title1 (@Type1_Fields) {
    Type1($title1);
  }
  $default__gateway;
  foreach $title2 (@Type2_Fields) {
    Type2($title2);
  }
  foreach $title3 (@Type3_Fields) {
    Type3($title3);
  }
  &Type2_analyze ();
  &Type3_analyze ();
  &OSPF  ();
  &BGP   ();
  &RIP   ();
  &EIGRP ();
  &IGRP  ();
  &create_config();
  return;
}
#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
sub Analyze_Information {
#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
  #worksheet_perserĂяo
  my $line;
  my $row = $_[0]+1;
  my $nrow = $_[1];
  my $title = $_[2];
  my $max_row = $_[3];
  my $max_col = $_[4];
  $debug1 && print "---------------------------------------------------------------";
  $debug1 && print "\n sub-Analyze_Information:Exec $title ";
  $debug1 && print " sub-Analyze_Information:Start row = $row:\$nrow = $nrow\n";

    if ($title =~ /System/) { $debug && print " sub-Analyze_Information: \$title --> System\n";return }
    if ($title =~ /Interface/) { INTERFACE($row,$nrow,$title,$max_row,$max_col);return }

    #.*_Information̒Ɋ܂܂Ă.*Parameter̈ʒu߂
    foreach my $row ($row..$nrow) {
      foreach my $col (1..$max_col)  {
       $line = $Sheet->Cells($row,$col)->{'Value'};
#       $line =~ s/\s/_/g;
#      $debug && print " sub-Analyze_Information:\$line = $line\n";

       if ($line =~ /(^.*Parameter)/) { list_parameter($&,$row,$col,$nrow,$max_row,$max_col) }
      }
    }

  #list_parameterɂč쐬ꂽ.*Parameter̈ꗗ@par_lsto͂
  $debug && print "  sub-Analyze_Information:sub-list_parameter create \@par_lst = \n  @par_lst";
  return;
}
#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
sub list_parameter {
#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
  #Analyze_InformationĂяo
  #Parameter̈ꗗ쐬A@par_lstɊi[
  my $line;
  my $parameter =   $_[0] . ":";
  my $row   = "R" . $_[1];
  my $col   = "C" . $_[2];
  my $nrow  =       $_[3];
  my $max_row =     $_[4];
  my $max_col =     $_[5];
  push (@rowlst,$_[1]);
  push (@collst,$_[2]);

  @row_lst = sort(@rowlst);
  @col_lst = sort(@collst);
  $debug1 && $TextBox01->ReplaceSel("  sub-list_parameter:\$parameter = \"$parameter\",\$row = $row:\$col = $col:\$nrow = $nrow\n");
  push(@par_lst,join(/,/,$parameter,$row,$col,"N".$nrow,"\n"));
  return;
}
#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
sub cell_box {
#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
  #worksheet_perserĂяo
  my $max_row =     $_[0];
  my $max_col =     $_[1];
  my $num;
  my $line;
  my $type = "";
  #@title_lst = ();
  $debug1 && $TextBox01->ReplaceSel("  sub-cell_box:\@col_lst = @col_lst\n");
  $debug1 && $TextBox01->ReplaceSel("  sub-cell_box:\@row_lst = @row_lst\n");

  foreach $rc_num (@par_lst) {
    $rc_num =~ /^(.+):R(\d+)C(\d+)N(\d+)/;
    #my $title = $1;
    $parameter_lst{"$1"} = $title_num ;
    $debug1 && $TextBox01->ReplaceSel("  sub-cell_box:\%parameter_lst = $parameter_lst{$1}\n");
    $debug1 && $TextBox01->ReplaceSel("  sub-cell_box:\%parameter_lst key = $1\n");
    my $row   = $2+1;
    my $col   = $3;
    my $nrow  = $4;


    #ncol߂
    foreach $num (@col_lst) {
      if ($col < $num) {
        $ncol = $num-2;
        last;
      } else {;
        if ($col > $num) { $ncol = $max_col }
        };
    }

    #push (@title_lst,$title);
    $debug1 && $TextBox01->ReplaceSel("  sub-cell_box:\$1 = $1:\$row = $row:\$nrow = $nrow:\$col = $col:\$ncol = $ncol\n");
    if ( $1 =~ "HSRP Parameter" ) { Type4($row,$nrow,$col,$ncol,$title_num,$max_row,$max_col,$type = "HSRP") };
    if ( $1 =~ "VLAN Parameter" ) { Type4($row,$nrow,$col,$ncol,$title_num,$max_row,$max_col,$type = "VLAN") };
    read_cell ($row,$nrow,$col,$ncol,$title_num,$max_row,$max_col);
  $title_num++;
  }
  @par_lst = ();
}

#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
sub read_cell {
#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
  #cell_boxĂяo

  my $row     = $_[0];
  my $nrow    = $_[1];
  my $col     = $_[2];
  my $ncol    = $_[3];
  my $title   = parameter . $_[4];
  my $max_row = $_[5];
  my $max_col = $_[6];

  my $line;
  @$title = ();
  $debug1 && $TextBox01->ReplaceSel("/*** sub-read_cell \$title = $title ***/\n");

  foreach my $row ($row..$nrow) {
    foreach my $col ($col..$ncol)  {
      next unless defined $Sheet->Cells($row,$col)->{'Value'};
      $line = $Sheet->Cells($row,$col)->{'Value'};
      if ($line =~ /Parameter/) { return ; }
      push (@$title,$line);
      $debug2 && $TextBox01->ReplaceSel("$line\n");
    }
  }
  $debug1 && $TextBox01->ReplaceSel("/*** sub-read_cell \$title = $title END ***/\n");
  return;
}
#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
sub Type1() {
#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
  #worksheet_perserĂяo
  #sPʂł̂܂ConfigƂėp^Cv
  my $field = undef;
  my $value = undef;
  my $line  = undef;
  my @temp = ();
  
  $debug1 && $TextBox01->ReplaceSel("sub-Type1:$_[0] Exec\n");
  $debug1 && $TextBox01->ReplaceSel("sub-Type1 $parameter_lst{\"$_[0]\"} \n");
  if ( exists $parameter_lst{$_[0]}){
  $debug1 && $TextBox01->ReplaceSel("sub-Type1 $_[0] is much \n");
    $title = parameter . $parameter_lst{"$_[0]"};
    $debug1 && $TextBox01->ReplaceSel("sub-Type1 \$title = $title \n");
    foreach $line (@$title) {
      push (@temp,$line . "\n");
    }
  }
  @$title = ();
  @$title = @temp;

  @temp = ();
  $debug1 && $TextBox01->ReplaceSel(" @$title \n");
  $debug1 && $TextBox01->ReplaceSel("/***sub-Type1 Complete ***/\n\n");
}
#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
sub Type2() {
#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
  #worksheet_perserĂяo
  #sɂ킩Ă^Cv
  my $field = undef;
  my $value = undef;
  $debug1 && $TextBox01->ReplaceSel("sub-Type2 $_[0] Exec\n");

  if ( exists $parameter_lst{$_[0]}){
    my $title = parameter . $parameter_lst{"$_[0]"};

    do{
    $field = shift(@$title);           # z̐擪$maeɓ
                                       # 1sڂp
    $value = shift(@$title);           # ̂$atoɓ
                                       # 2sڂ{
    unless ($value eq "none") {
      $command{$field} = $value;
      $debug1 && $TextBox01->ReplaceSel(" sub-Type2:\$command{$field} = $command{$field} \n");
    }

    }until(@$title[0] eq '');          # z̗vfɂȂ܂
  }

  $debug1 && $TextBox01->ReplaceSel(" @$title sub-Type2 Task Complete.\n\n");
}
#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
sub Type3() {
#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
  #worksheet_perserĂяo
  #~Ŕf^Cv
  #my $title = $_[0];
  my $field = undef;
  my $value = undef;
  $debug1 && $TextBox01->ReplaceSel("sub-Type3 $title Exec\n");
  if ( exists $parameter_lst{$_[0]}){
    $title = parameter . $parameter_lst{"$_[0]"};
  do{
    $field = shift(@$title);           # z̐擪$maeɓ
                                       # 1sڂp
    $value = shift(@$title);           # ̂$atoɓ
                                       # 2sڂ{

    $command{$field} = $value;
    $debug1 && $TextBox01->ReplaceSel(" sub-Type3:\$command{$field} = $command{$field} \n");
    push (@Type3_list,$field . "," . $value);

    }until(@$title[0] eq '');          # z̗vfɂȂ܂
  }

  $debug1 && $TextBox01->ReplaceSel(" @$title sub-Type3 Task Complete.\n\n");
}
#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
sub Type4() {
#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
  #cell_boxĂяo
  my $row     = $_[0];
  my $nrow    = $_[1];
  my $col     = $_[2];
  my $ncol    = $_[3];
  my $title   = parameter . $_[4];
  my $max_row = $_[5];
  my $max_col = $_[6];
  my $type    = $_[7];

  my $line    = undef;
  my $test    = undef;
  my @temp = ();
  my @TYPE4_ROW = ();
  my @TYPE4_COL = ();
  @$title = ();
  $debug1 && $TextBox01->ReplaceSel("--------sub Type4--------");
  $debug1 && $TextBox01->ReplaceSel("\n sub-Type4:Exec $title \n");
  $debug1 && $TextBox01->ReplaceSel(" sub-Type4:Start row = $row:\$nrow = $nrow\n");

  #Field-Title̓ǂݎ
    foreach my $col ($col..$ncol)  {
      next unless defined $Sheet->Cells($row,$col)->{'Value'};
      $line = $Sheet->Cells($row,$col)->{'Value'} . ",";
      push (@TYPE4_COL,$col)
    }
    $debug1 && $TextBox01->ReplaceSel(" sub-Type4:\@TYPE4_COL = @TYPE4_COL\n");

    foreach my $row ($row+1..$nrow)  {
      next unless defined $Sheet->Cells($row,$col)->{'Value'};
      $line = $Sheet->Cells($row,$col)->{'Value'} . ",";
      if ($line =~ /(^.*Parameter)/) { last };
      push (@TYPE4_ROW,$row)
    }
    $debug1 && $TextBox01->ReplaceSel(" sub-Type4:\@TYPE4_ROW = @TYPE4_ROW\n");

  #Field̓ǂݎ
  foreach my $row (@TYPE4_ROW) {
    foreach my $col (@TYPE4_COL)  {
      $line =$Sheet->Cells($row,$col)->{'Value'} . ",";
      push (@temp,$line);
    }
    push (@temp,"\n");
    $temp = join(/\n/,@temp);
    push (@$title,$temp);
    @temp = ();
  }

  $debug1 && $TextBox01->ReplaceSel(" sub-Type4:\@\$title = \n @$title\n ---end\n");
  $debug1 && $TextBox01->ReplaceSel(" sub-Type4:\$type = $type \n");

  if ($type eq "HSRP") {Type4_HSRP($title);@$title = (); }
  if ($type eq "VLAN") {Type4_VLAN($title);@$title = (); }

}
#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
sub Type4_HSRP  {
#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    my $title = $_[0];
    my $line1 = undef;
    $debug1 && $TextBox01->ReplaceSel(" sub-Type4_HSRP:\$title = $title\n");
    $debug1 && $TextBox01->ReplaceSel("  sub-Type4_HSRP:\@\$title = \n @$title\n");
    @HSRP = ();
    @temp =();
    foreach $line1 (@$title) {
      ($HSRP_INT,$HSRP_ID,$HSRP_VIP,$HSRP_PRIORITY,$HSRP_TRACK,$HSRP_PREEMPT) = split(/,/,$line1);
      push (@temp,$HSRP_INT . ",");
      push (@temp," standby " . $HSRP_ID . " ip " . $HSRP_VIP . ",");
      push (@temp," standby " . $HSRP_ID . " priority " . $HSRP_PRIORITY . ",");
      unless ($HSRP_TRACK eq "") {
        push (@temp," standby " . $HSRP_ID . " track " . $HSRP_TRACK . ",");
      }
      unless ($HSRP_PREEMPT eq "") {
        push (@temp," standby " . $HSRP_ID . " preempt" . ",");
      }
      push (@temp,"\n");
      $temp = join(/\n/,@temp);
      push (@HSRP,$temp);
      @temp = ();
    }
      $debug1 && $TextBox01->ReplaceSel("  sub-Type4:HSRP:\@HSRP = \n @HSRP\n\n");
      return;
}
#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
sub Type4_VLAN {
#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    my $title = $_[0];
    my $line2 = undef;
    $debug1 && $TextBox01->ReplaceSel(" sub-Type4_VLAN:\$title = $title\n");
    $debug1 && $TextBox01->ReplaceSel(" sub-Type4_VLAN:\@\$title = \n @$title\n");
    @VLAN = ();
    @VLAN_STP = ();
    foreach $line2 (@$title) {
      ($VLAN_NAME,$VLAN_NO,$VLAN_STP_MODE,$VLAN_STP_PRIORITY,$VLAN_STP_FORWARD_TIME,$VLAN_STP_HELLO_TIME,$VLAN_STP_MAXAGE) = split(/,/,$line2);
      push (@VLAN,"vlan " . $VLAN_NO . "\n");
      push (@VLAN," name " . $VLAN_NAME . "\n");
      push (@VLAN,"!\n");

      #VLAN_STP
      unless ($VLAN_STP_MODE eq "") {
        if ($VLAN_STP_MODE =~ /.*1d/) {
          push (@VLAN_STP,"spanning-tree vlan $VLAN_NO priority $VLAN_STP_PRIORITY\n");
          push (@VLAN_STP,"spanning-tree vlan $VLAN_NO max-age $VLAN_STP_MAX_AGE\n");
          push (@VLAN_STP,"spanning-tree vlan $VLAN_NO hello-time $VLAN_STP_HELLO_TIME\n");
          push (@VLAN_STP,"spanning-tree vlan $VLAN_NO forward-time $VLAN_STP_FORWARD_TIME\n");
        }
        if ($VLAN_STP_MODE =~ /[mst]|[rstp]/) {
          push (@VLAN_STP,"spanning-tree mode mst\n");
          push (@VLAN_STP,"spanning-tree mst hello-time $VLAN_STP_HELLO_TIME\n");
          push (@VLAN_STP,"spanning-tree mst forward-time $VLAN_STP_FORWARD_TIME\n");
          push (@VLAN_STP,"spanning-tree mst max-age $VLAN_STP_MAXAGE\n");
          push (@VLAN_STP,"spanning-tree mst 0-1 priority $VLAN_STP_PRIORITY\n");
          push (@VLAN_STP,"spanning-tree mst configuration\n");
        }
      }

    }
      @$title = ();
      $debug1 && $TextBox01->ReplaceSel("  sub-Type4:VLAN:\@VLAN = \n @VLAN\n\n");
      $debug1 && $TextBox01->ReplaceSel("  sub-Type4:VLAN:\@VLAN_STP = \n @VLAN_STP\n\n");
      return;
}


#---------------------
#Field-Analyze
#---------------------
#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
sub Type2_analyze {
#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
  #worksheet_perserĂяo
  my $field = undef;
  my $line1 = undef;
  my $line2 = undef;
  my $i = 0;
  my $a = 0;
  @field_list = ();
  $debug1 && $TextBox01->ReplaceSel("/***sub Type2_analyze***/\n");

  foreach $line (@Type2_regexp) {
    $line =~ /(.*),(.*),(.*)/;
    my $field   = $1;
    my $result  = $2;
    my $action  = $3;
       $debug1 && $TextBox01->ReplaceSel("Type2_analyze - \$field = $field\n");
       $debug1 && $TextBox01->ReplaceSel("Type2_analyze - \$result = $result\n");

    TYPE2_ACTION: {
      $debug1 && $TextBox01->ReplaceSel("Type2_analyze - \$action = $action\n");
      if ($action eq "replace")     { Type2_replace($field,$result)   ; last TYPE2_ACTION; }
      if ($action eq "chomp")       { Type2_chomp($field,$result)     ; last TYPE2_ACTION; }
      if ($action eq "drop")        { Type2_drop($field,$result)      ; last TYPE2_ACTION; }
      if ($action eq "choice")      { Type2_choice($field,$result)    ; last TYPE2_ACTION; }
      if ($action =~ /append_(.*)/) { Type2_append($field,$result,$1) ; last TYPE2_ACTION; }
      if ($action eq "")            { Type2_replace($field,$result)   ; last TYPE2_ACTION; }
    }

  }
}
sub Type2_chomp {
    my $field   = $_[0];
    my $result  = $_[1];

    if ( exists $command{$field} ) {
       $result_value = $command{$field};
       $command{$field} = $result . $result_value;
       $debug1 && $TextBox01->ReplaceSel("Type2_analyze - success $command{$field} \n");
    }
}

sub Type2_replace {
    my $field   = $_[0];
    my $result  = $_[1];
       $debug1 && $TextBox01->ReplaceSel("Type2_analyze - replace $command{$field} \n");

    if ( exists $command{$field} ) {
       $result_value = $command{$field};
       $command{$field} = $result . $result_value . "\n";
       $debug1 && $TextBox01->ReplaceSel("Type2_analyze - success $command{$field} \n");
    }
}

sub Type2_append {
    my $field   = $_[0];
    my $result  = $_[1];
    my $append  = $_[2];

    if ( exists $command{$field} ) {
       $result_value = $command{$field};
       $command{$field} = $result . $result_value . $append . "\n";
       $debug1 && $TextBox01->ReplaceSel("Type2_analyze - success $command{$field} \n");
    }
}

sub Type2_drop {
    my $field   = $_[0];
    my $result  = $_[1];

    if ( exists $command{$field} ) {
       $result_value = $command{$field};
       $command{$field} = $result . "\n";
       $debug1 && $TextBox01->ReplaceSel("Type2_analyze - success $command{$field} \n");
    }
}

sub Type2_choice {
    my $field   = $_[0];
    my $result  = $_[1];

    if ( exists $command{$field} ) {
       $result_value = $command{$field};
       if ($result_value eq "disable") {
         $command{$field} = "no" . $result . "\n";
       }  else {
            $command{$field} = $result . "\n";
          }
       $debug1 && $TextBox01->ReplaceSel("Type2_analyze - success $command{$field} \n");
    }
}


#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
sub Type3_analyze {
#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
  #worksheet_perserĂяo
  my $line1 = undef;
  my $line2 = undef;
  my $peg   = undef;
  my $field = undef;
  my @item = ();
  $debug1 && $TextBox01->ReplaceSel("sub-Type3_analyze Type3 Analyze exec\n");
  $debug1 && $TextBox01->ReplaceSel("sub-Type3_analyze:Type3_list = @Type3_list\n");

  foreach $line1 (@Type3_list) {
      $debug1 && $TextBox01->ReplaceSel("sub-Type3_analyze:line1 = $line1");
      $line1 =~ /(.*),(|~)/;
      $field = $1;
      $debug && print "sub-Type3_analyze:\$1 = " . $1 ."\n";
      $debug && print "\$2 = " . $2 . "\n";
      if ($2 =~ //) { $peg = "" } else { $peg = "no " };
      $debug1 && $TextBox01->ReplaceSel("sub-Type3_analyze:\$field = $field \$peg = $peg\n");
      $command{$field} = $peg . $field . "\n";
  }
}
#---------------------
# INTERFACE
#---------------------
sub INTERFACE {
  my $row   = $_[0]+2;
  my $nrow  = $_[1];
  my $title = $_[2];
  my $max_row = $_[3];
  my $max_col = $_[4];
  my $line  = undef;
  my $test  = undef;
  my @temp = ();
  my $col   = undef;

  @INT_LIST = ();
  @INTERFACE = ();
  @INT_COL = ();
  @INT_ROW = ();

  $debug1 && $TextBox01->ReplaceSel("-------------------Sub INTERFACE----------------------------");
  $debug1 && $TextBox01->ReplaceSel("\n sub-INTERFACE:Exec $title \n");
  $debug1 && $TextBox01->ReplaceSel(" sub-INTERFACE:Start \$row = $row:\$nrow = $nrow \$max_col = $max_col\n");

  #Field-Title̓ǂݎ
    foreach $col (2..$max_col)  {
      next unless defined $Sheet->Cells($row,$col)->{'Value'};
      $line = $Sheet->Cells($row,$col)->{'Value'} . ",";
      push (@INT_COL,$col)
    }
    $debug && print " sub-INTERFACE:\@INT_COL = @INT_COL\n";

    foreach my $row ($row+1..$nrow)  {
      next unless defined $Sheet->Cells($row,2)->{'Value'};
      $line = $Sheet->Cells($row,$col)->{'Value'} . ",";
      push (@INT_ROW,$row)
    }
    $debug && print " sub-INTERFACE:\@INT_ROW = @INT_ROW\n";

  #Field̓eǂݎĂ
  foreach my $row (@INT_ROW) {
    foreach my $col (@INT_COL)  {
      $line =$Sheet->Cells($row,$col)->{'Value'} . ",";
      push (@temp,$line);
    }
    push (@temp,"\n");
    $temp = join(/\n/,@temp);
    push (@INT_LIST,$temp);
    @temp = ();
  }

  $debug && print " sub-INTERFACE:\@INT_LIST = \n @INT_LIST\n";

  #eC^[tF[X̏ɂ
  foreach $line (@INT_LIST) {
    (
        $INT_SLOT,
        $INT_IP_ADDRESS,
        $INT_SUBNETMASK,
        $INT_DESCRIPTION,
        $INT_STATUS,
        $INT_SPEED,
        $INT_CDP,
        $INT_CHANNEL,
        $INT_VLAN_MODE,
        $INT_VLAN_ASSIGN,
        $INT_VLAN_TYPE,
        $INT_VLAN_ALLOWED_VLAN,
        $INT_STP_PF,
        $INT_STP_LG,
        $INT_STP_RG,
        $INT_STP_COST,
        $INT_OSPF_COST,
        $INT_OSPF_HT,
        $INT_OSPF_PRI,
        $INT_LINK_LOG,
        $INT_LINK_SNMP,
        @OTHER,
      ) = split(/,/,$line);
    #push (@INT_SLOT_LIST,$INT_SLOT);
    $INT_SLOT =~ s/\s//g;
    push (@INTERFACE,"interface "    . $INT_SLOT . "\n");
    unless ($INT_DESCRIPTION eq "" ) { push (@INTERFACE," description " . $INT_DESCRIPTION  . "\n") };
    unless ($INT_IP_ADDRESS eq "" ) { push (@INTERFACE," ip address "  . $INT_IP_ADDRESS . " " . $INT_SUBNETMASK. "\n") };
    if ($INT_STATUS =~ /shutdown/) { push (@INTERFACE," shutdown\n") } else { push (@INTERFACE," no shutdown\n") };
    unless ($INT_SPEED eq "" ) { $INT_SPEED =~ /(.*)\/(.*)/;
       push (@INTERFACE," speed $1\n");
       push (@INTERFACE," duplex $2\n");
    }
    if ($INT_CDP =~ //) { push (@INTERFACE," cdp enable\n") } else { push (@INTERFACE," no cdp enable\n") };

    #INT_CHANNEL
    if ($INT_CHANNEL == "") { ; } else {
      $INT_CHANNEL =~ /(\d+)/;
        push (@INTERFACE," channel-group $& mode desirable\n");
    }

    #SWITCH-PORT
    $debug1 && print " sub-INTERFACE:\$INT_VLAN_MODE = $INT_VLAN_MODE\n";

    unless ($INT_VLAN_MODE == undef) { ; } else {
        if ($INT_VLAN_MODE =~ /routed/) {
          $debug1 && print " sub-INTERFACE:\$INT_VLAN_MODE is access \n";
          push (@INTERFACE," no switchport\n");
          }
        if ($INT_VLAN_MODE =~ /access/) {
          $debug1 && print " sub-INTERFACE:\$INT_VLAN_MODE is access \n";
          push (@INTERFACE," switchport\n");
          push (@INTERFACE," switchport mode $INT_VLAN_MODE\n");
          push (@INTERFACE," switchport access vlan $INT_VLAN_ASSIGN\n");
          }
        if ($INT_VLAN_MODE =~ /trunk/) {
          $debug1 && print " sub-INTERFACE:\$INT_VLAN_MODE is trunk \n";
          push (@INTERFACE," switchport\n");
          push (@INTERFACE," switchport trunk encapsulation $INT_VLAN_TYPE\n");
          push (@INTERFACE," switchport mode $INT_VLAN_MODE\n");
          push (@INTERFACE," switchport trunk allowed vlan $INT_VLAN_ALLOWED_VLAN\n");
          }
    }

    #INT_STP
    if ($INT_STP_PF =~ "") { push (@INTERFACE," spanning-tree portfast\n")    } else { ; }
    if ($INT_STP_LG =~ "") { push (@INTERFACE," spanning-tree guard loop\n")  } else { ; }
    if ($INT_STP_RG =~ "") { push (@INTERFACE," spanning-tree guard root\n")  } else { ; }
    if ($INT_STP_COST == "") { ; } else { push (@INTERFACE," spanning-tree cost $INT_STP_COST\n"); }

    #INT_OSPF
    if ($INT_OSPF_COST  == "") { ; } else { push (@INTERFACE," ip ospf cost $INT_OSPF_COST\n"); }
    if ($INT_OSPF_HT    == "") { ; } else { push (@INTERFACE," ip ospf hello-interval $INT_OSPF_HT\n"); }
    if ($INT_OSPF_PRI   == "") { ; } else { push (@INTERFACE," ip ospf priority $INT_OSPF_PRI\n"); }

    #INT_LINK-STATUS
    if ($INT_LINK_LOG  =~ "") { push (@INTERFACE," logging event link-status\n"); } else { push (@INTERFACE," no logging event link-status\n"); }
    if ($INT_LINK_SNMP =~ "") { push (@INTERFACE," snmp trap link-status\n"); } else { push (@INTERFACE," no snmp trap link-status\n"); }

    #HSRP
    foreach $line1 (@HSRP) {
      (
        my $HSRP_INT,
        my $HSRP_VIP,
        my $HSRP_PRIORITY,
        my $HSRP_TRACK,
        my $HSRP_PREEMPT,
      ) = split(/,/,$line1);
      $debug1 && print "sub-INTERFACE:\$HSRP_INT = $HSRP_INT <==> \$INT_SLOT = $INT_SLOT\n";
      if ($INT_SLOT eq $HSRP_INT) {
      $debug1 && print "sub-INTERFACE:\$HSRP_INT AND \$INT_SLOT is much\n";
          push (@INTERFACE," no ip redirects" . "\n");
          push (@INTERFACE,"$HSRP_VIP" . "\n");
          push (@INTERFACE,"$HSRP_PRIORITY" . "\n");
          $debug1 && print "sub-INTERFACE:\$HSRP_TRACK = $HSRP_TRACK\n";
          if ($HSRP_TRACK =~ /^\n/) { ; } else {
            $debug1 && print "sub-INTERFACE:\$HSRP_TRACK = Value Include\n";
            push (@INTERFACE,"$HSRP_TRACK" . "\n");
            push (@INTERFACE,"$HSRP_PREEMPT" . "\n");
          }
      }
    }

    #INT-END
    push (@INTERFACE,"!\n");
  }
  $debug1 && print @INT_SLOT_LIST;
}

#---------------------
# Dynamic Routing
#---------------------
sub OSPF {
  $debug1 && print "sub-OSPF:OSPF Exec\n";
  @OSPF = ();
  push (@OSPF,$command{"OSPF Process ID"});
  push (@OSPF,$command{"OSPF Router ID"});
  push (@OSPF,$command{"OSPF Logging"});
  push (@OSPF,convert_blank("OSPF Redistribute Parameter"));
  push (@OSPF,convert_blank("OSPF Passive Interface Parameter"));
  push (@OSPF,convert_blank("OSPF Advertise Network Parameter"));
  $debug1 && print "sub-OSPF:\@OSPF = \n @OSPF \n";
}

sub BGP {
  $debug1 && print "sub-BGP:BGP Exec\n";
  @BGP = ();
  push (@BGP,$command{"BGP Process ID"});
  push (@BGP,$command{"BGP Router ID"});
  push (@BGP,$command{"BGP Logging"});
  push (@BGP,convert_blank("BGP Neighbor Parameter"));
  push (@BGP,convert_blank("BGP Aggregate-address Parameter"));
  push (@BGP,convert_blank("BGP Advertise Network Parameter"));
  push (@BGP,convert_blank("BGP Passive Interface Parameter"));
  push (@BGP,convert_blank("BGP Redistribute Parameter"));
  $debug1 && print "sub-BGP:\@BGP = \n @BGP \n";
}

sub RIP {
  $debug1 && print "sub-RIP:RIP Exec\n";
  @RIP = ();
  push (@RIP,$command{"RIP Process ID"});
  push (@RIP,$command{"RIP Router ID"});
  push (@RIP,$command{"RIP Logging"});
  push (@RIP,convert_blank("RIP Redistribute Parameter"));
  push (@RIP,convert_blank("RIP Passive Interface Parameter"));
  push (@RIP,convert_blank("RIP Advertise Network Parameter"));
  $debug1 && print "sub-RIP:\@RIP = \n @RIP \n";
}

sub IGRP {
  $debug1 && print "sub-IGRP:IGRP Exec\n";
  @IGRP = ();
  push (@IGRP,$command{"IGRP Process ID"});
  push (@IGRP,$command{"IGRP Router ID"});
  push (@IGRP,$command{"IGRP Logging"});
  push (@IGRP,convert_blank("IGRP Redistribute Parameter"));
  push (@IGRP,convert_blank("IGRP Passive Interface Parameter"));
  push (@IGRP,convert_blank("IGRP Advertise Network Parameter"));
  $debug1 && print "sub-IGRP:\@IGRP = \n @IGRP \n";
}

sub EIGRP {
  $debug1 && print "sub-EIGRP:EIGRP Exec\n";
  @IGRP = ();
  push (@EIGRP,$command{"EIGRP Process ID"});
  push (@EIGRP,$command{"EIGRP Router ID"});
  push (@EIGRP,$command{"EIGRP Logging"});
  push (@EIGRP,convert_blank("EIGRP Redistribute Parameter"));
  push (@EIGRP,convert_blank("EIGRP Passive Interface Parameter"));
  push (@EIGRP,convert_blank("EIGRP Advertise Network Parameter"));
  $debug1 && print "sub-EIGRP:\@EIGRP = \n @EIGRP \n";
}


#---------------------
#Config-Output
#---------------------
sub create_config() {
  my $host_name =$Sheet->Name;
  fileparse($file_name01);
  $List03->InsertItem("$path$host_name.cfg");
  #$TextBox01->ReplaceSel(" --> Created CFG $host_name.cfg\n");
  open(CFG,">$host_name.cfg");

  #worksheet_perserĂяo
  #
  #6500p
  #
  print CFG "!============================================================================\n";
  print CFG "!This configration created by [xls2cfg Version $my_version]\n";
  print CFG "! from $path$name$suffix Sheet = " . $Sheet->Name . "\n";
  print CFG "!============================================================================\n";
  print CFG convert("General Service configration Parameter");
  print CFG "!\n";
  print CFG convert("hostname");
  print CFG convert("cdp run");
  print CFG "!\n";
  print CFG convert("boot system");
  print CFG convert("boot system2");
  print CFG convert("logging buffered");
  print CFG "!\n";
  print CFG convert("Clock Timezone");
  print CFG convert("diagnostic level");
  print CFG convert("VTP Mode");
  print CFG convert("ip finger");
  print CFG convert("ip subnet-zero");
  print CFG convert("ip routing");
  print CFG convert("ip domain-lookup");
  print CFG "!\n";
  print CFG convert("VLAN_STP");
  print CFG convert("MST Name");
  print CFG convert("MST Instance 0 vlan");
  print CFG convert("MST Instance 1 vlan");
  print CFG convert("fabric lcd banner");
  print CFG "!\n";
  print CFG convert("VLAN");
  print CFG convert("INTERFACE");
  print CFG "!\n";
  print CFG convert("OSPF");
  print CFG "!\n";
  print CFG convert("BGP");
  print CFG convert("RIP");
  print CFG convert("EIGRP");
  print CFG convert("IGRP");
  print CFG "!\n";
  print CFG convert("default gateway");
  print CFG convert("ip classless");
  print CFG convert("Static Route Parameter");
  print CFG convert("ip http server");
  print CFG "!\n";
  print CFG convert("Syslog Server IP1");
  print CFG convert("Logging Level");
  print CFG convert("Logging Facility");
  print CFG convert("Static Arp Parameter");
  print CFG convert("Community RO");
  print CFG convert("Community RW");
  print CFG convert("Trap Host");print CFG convert("Trap Community");print CFG convert("Use Trap");
  print CFG "!\n";
  print CFG "banner exec ^\n";
  print CFG convert("Banner exec Parameter");
  print CFG "\^\n";
  print CFG "banner login ^\n";
  print CFG convert("Banner login Parameter");
  print CFG "\^\n";
  print CFG "!\n";
  print CFG convert("MAC Address Aging Parameter");
  print CFG convert("NTP Mode");
  print CFG convert("NTP Server IP1");
  print CFG convert("NTP Server IP2");
  print CFG convert("Update Calender");
  print CFG "end\n";
  close (CFG);
  $Status01->Text("Task Complete.");
  all_delete();

}

#====================================================================
# Function
#====================================================================
sub convert {
    my $original  = $_[0];
    my $title = parameter . $parameter_lst{"$_[0]"};
    return @$title , $command{"$_[0]"} , @$original;
}

sub convert_blank {
    my $title = parameter . $parameter_lst{"$_[0]"};
    return " @$title";
}


sub all_delete {
  my $num = "";
  foreach $num ( keys( %parameter_lst ) ) {
    $debug1 && $TextBox01->ReplaceSel("all_delete:\@\$parameter_lst{\$num} = \@parameter$parameter_lst{$num} is delete\n");
    my $title = parameter . $parameter_lst{$num};
    $debug1 && $TextBox01->ReplaceSel("all_delete:\@$title = @$title\n");
    @$title = ();
    $debug1 && $TextBox01->ReplaceSel("all_delete:\@$title = @$title\n\n");
  }
}

sub fileparse {
  my $file_name = $_[0];
  $path = "";
  $name = "";
  $suffix = "";
  $file_name =~ s/\\/\//g;
  if ($file_name =~ /\//) {
    if ( $file_name =~ /\./) {
      $file_name  =~ /(.*\/)(.+)\.(.*)/;
      $path        = $1;
      $name       = $2;
      $suffix  = $3;
      } else {
        $debu && print "  path include but not extension\n";
        $file_name =~ /(.*\/)(.+)/;
        $path       = $1;
        $name      = $2;
      }
    } else {
    if ($file_name =~ /(.*)\.(.*)/) {
      $debug && print "  not path extension include\n";
      $name       = $1;
      $suffix  = $2;
    } else {
      $debug && print "  not path not extension\n";
      $file_name  =~ /(.*)/;
      $name       = $&;
      }
  }
  return $path,$name,$suffix;
}


